Index: /NEMO/branches/2020/temporary_r4_trunk/src/OCE/DYN/dynspg_ts.F90
===================================================================
--- /NEMO/branches/2020/temporary_r4_trunk/src/OCE/DYN/dynspg_ts.F90	(revision 13468)
+++ /NEMO/branches/2020/temporary_r4_trunk/src/OCE/DYN/dynspg_ts.F90	(revision 13469)
@@ -1246,56 +1194,48 @@
       SELECT CASE( nvor_scheme )
       CASE( np_ENT )                ! enstrophy conserving scheme (f-point)
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               z1_hu = ssumask(ji,jj) / ( hu_n(ji,jj) + 1._wp - ssumask(ji,jj) )
-               z1_hv = ssvmask(ji,jj) / ( hv_n(ji,jj) + 1._wp - ssvmask(ji,jj) )
-               zu_trd(ji,jj) = + r1_4 * r1_e1e2u(ji,jj) * z1_hu                    &
-                  &               * (  e1e2t(ji+1,jj)*ht_n(ji+1,jj)*ff_t(ji+1,jj) * ( vn_b(ji+1,jj) + vn_b(ji+1,jj-1) )   &
-                  &                  + e1e2t(ji  ,jj)*ht_n(ji  ,jj)*ff_t(ji  ,jj) * ( vn_b(ji  ,jj) + vn_b(ji  ,jj-1) )   )
-                  !
-               zv_trd(ji,jj) = - r1_4 * r1_e1e2v(ji,jj) * z1_hv                    &
-                  &               * (  e1e2t(ji,jj+1)*ht_n(ji,jj+1)*ff_t(ji,jj+1) * ( un_b(ji,jj+1) + un_b(ji-1,jj+1) )   & 
-                  &                  + e1e2t(ji,jj  )*ht_n(ji,jj  )*ff_t(ji,jj  ) * ( un_b(ji,jj  ) + un_b(ji-1,jj  ) )   ) 
-            END DO  
-         END DO  
+         DO_2D_00_00
+            z1_hu = ssumask(ji,jj) / ( hu_n(ji,jj) + 1._wp - ssumask(ji,jj) )
+            z1_hv = ssvmask(ji,jj) / ( hv_n(ji,jj) + 1._wp - ssvmask(ji,jj) )
+            zu_trd(ji,jj) = + r1_4 * r1_e1e2u(ji,jj) * z1_hu                    &
+               &               * (  e1e2t(ji+1,jj)*ht_n(ji+1,jj)*ff_t(ji+1,jj) * ( vn_b(ji+1,jj) + vn_b(ji+1,jj-1) )   &
+               &                  + e1e2t(ji  ,jj)*ht_n(ji  ,jj)*ff_t(ji  ,jj) * ( vn_b(ji  ,jj) + vn_b(ji  ,jj-1) )   )
+               !
+            zv_trd(ji,jj) = - r1_4 * r1_e1e2v(ji,jj) * z1_hv                    &
+               &               * (  e1e2t(ji,jj+1)*ht_n(ji,jj+1)*ff_t(ji,jj+1) * ( un_b(ji,jj+1) + un_b(ji-1,jj+1) )   & 
+               &                  + e1e2t(ji,jj  )*ht_n(ji,jj  )*ff_t(ji,jj  ) * ( un_b(ji,jj  ) + un_b(ji-1,jj  ) )   ) 
+         END_2D
          !         
       CASE( np_ENE , np_MIX )        ! energy conserving scheme (t-point) ENE or MIX
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zy1 = ( zhV(ji,jj-1) + zhV(ji+1,jj-1) ) * r1_e1u(ji,jj)
-               zy2 = ( zhV(ji,jj  ) + zhV(ji+1,jj  ) ) * r1_e1u(ji,jj)
-               zx1 = ( zhU(ji-1,jj) + zhU(ji-1,jj+1) ) * r1_e2v(ji,jj)
-               zx2 = ( zhU(ji  ,jj) + zhU(ji  ,jj+1) ) * r1_e2v(ji,jj)
-               ! energy conserving formulation for planetary vorticity term
-               zu_trd(ji,jj) =   r1_4 * ( zwz(ji  ,jj-1) * zy1 + zwz(ji,jj) * zy2 )
-               zv_trd(ji,jj) = - r1_4 * ( zwz(ji-1,jj  ) * zx1 + zwz(ji,jj) * zx2 )
-            END DO
-         END DO
+         DO_2D_00_00
+            zy1 = ( zhV(ji,jj-1) + zhV(ji+1,jj-1) ) * r1_e1u(ji,jj)
+            zy2 = ( zhV(ji,jj  ) + zhV(ji+1,jj  ) ) * r1_e1u(ji,jj)
+            zx1 = ( zhU(ji-1,jj) + zhU(ji-1,jj+1) ) * r1_e2v(ji,jj)
+            zx2 = ( zhU(ji  ,jj) + zhU(ji  ,jj+1) ) * r1_e2v(ji,jj)
+            ! energy conserving formulation for planetary vorticity term
+            zu_trd(ji,jj) =   r1_4 * ( zwz(ji  ,jj-1) * zy1 + zwz(ji,jj) * zy2 )
+            zv_trd(ji,jj) = - r1_4 * ( zwz(ji-1,jj  ) * zx1 + zwz(ji,jj) * zx2 )
+         END_2D
          !
       CASE( np_ENS )                ! enstrophy conserving scheme (f-point)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zy1 =   r1_8 * ( zhV(ji  ,jj-1) + zhV(ji+1,jj-1) &
-                 &            + zhV(ji  ,jj  ) + zhV(ji+1,jj  ) ) * r1_e1u(ji,jj)
-               zx1 = - r1_8 * ( zhU(ji-1,jj  ) + zhU(ji-1,jj+1) &
-                 &            + zhU(ji  ,jj  ) + zhU(ji  ,jj+1) ) * r1_e2v(ji,jj)
-               zu_trd(ji,jj)  = zy1 * ( zwz(ji  ,jj-1) + zwz(ji,jj) )
-               zv_trd(ji,jj)  = zx1 * ( zwz(ji-1,jj  ) + zwz(ji,jj) )
-            END DO
-         END DO
+         DO_2D_00_00
+            zy1 =   r1_8 * ( zhV(ji  ,jj-1) + zhV(ji+1,jj-1) &
+              &            + zhV(ji  ,jj  ) + zhV(ji+1,jj  ) ) * r1_e1u(ji,jj)
+            zx1 = - r1_8 * ( zhU(ji-1,jj  ) + zhU(ji-1,jj+1) &
+              &            + zhU(ji  ,jj  ) + zhU(ji  ,jj+1) ) * r1_e2v(ji,jj)
+            zu_trd(ji,jj)  = zy1 * ( zwz(ji  ,jj-1) + zwz(ji,jj) )
+            zv_trd(ji,jj)  = zx1 * ( zwz(ji-1,jj  ) + zwz(ji,jj) )
+         END_2D
          !
       CASE( np_EET , np_EEN )      ! energy & enstrophy scheme (using e3t or e3f)         
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zu_trd(ji,jj) = + r1_12 * r1_e1u(ji,jj) * (  ftne(ji,jj  ) * zhV(ji  ,jj  ) &
-                &                                         + ftnw(ji+1,jj) * zhV(ji+1,jj  ) &
-                &                                         + ftse(ji,jj  ) * zhV(ji  ,jj-1) &
-                &                                         + ftsw(ji+1,jj) * zhV(ji+1,jj-1) )
-               zv_trd(ji,jj) = - r1_12 * r1_e2v(ji,jj) * (  ftsw(ji,jj+1) * zhU(ji-1,jj+1) &
-                &                                         + ftse(ji,jj+1) * zhU(ji  ,jj+1) &
-                &                                         + ftnw(ji,jj  ) * zhU(ji-1,jj  ) &
-                &                                         + ftne(ji,jj  ) * zhU(ji  ,jj  ) )
-            END DO
-         END DO
+         DO_2D_00_00
+            zu_trd(ji,jj) = + r1_12 * r1_e1u(ji,jj) * (  ftne(ji,jj  ) * zhV(ji  ,jj  ) &
+             &                                         + ftnw(ji+1,jj) * zhV(ji+1,jj  ) &
+             &                                         + ftse(ji,jj  ) * zhV(ji  ,jj-1) &
+             &                                         + ftsw(ji+1,jj) * zhV(ji+1,jj-1) )
+            zv_trd(ji,jj) = - r1_12 * r1_e2v(ji,jj) * (  ftsw(ji,jj+1) * zhU(ji-1,jj+1) &
+             &                                         + ftse(ji,jj+1) * zhU(ji  ,jj+1) &
+             &                                         + ftnw(ji,jj  ) * zhU(ji-1,jj  ) &
+             &                                         + ftne(ji,jj  ) * zhU(ji  ,jj  ) )
+         END_2D
          !
       END SELECT
@@ -1322,24 +1262,20 @@
       !
       IF( ln_wd_dl_rmp ) THEN     
-         DO jj = 1, jpj
-            DO ji = 1, jpi                    
-               IF    ( pssh(ji,jj) + ht_0(ji,jj) >  2._wp * rn_wdmin1 ) THEN 
-                  !           IF    ( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin2 ) THEN 
-                  ptmsk(ji,jj) = 1._wp
-               ELSEIF( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin1 ) THEN
-                  ptmsk(ji,jj) = TANH( 50._wp*( ( pssh(ji,jj) + ht_0(ji,jj) -  rn_wdmin1 )*r_rn_wdmin1) )
-               ELSE 
-                  ptmsk(ji,jj) = 0._wp
-               ENDIF
-            END DO
-         END DO
+         DO_2D_11_11
+            IF    ( pssh(ji,jj) + ht_0(ji,jj) >  2._wp * rn_wdmin1 ) THEN 
+               !           IF    ( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin2 ) THEN 
+               ptmsk(ji,jj) = 1._wp
+            ELSEIF( pssh(ji,jj) + ht_0(ji,jj) >          rn_wdmin1 ) THEN
+               ptmsk(ji,jj) = TANH( 50._wp*( ( pssh(ji,jj) + ht_0(ji,jj) -  rn_wdmin1 )*r_rn_wdmin1) )
+            ELSE 
+               ptmsk(ji,jj) = 0._wp
+            ENDIF
+         END_2D
       ELSE  
-         DO jj = 1, jpj
-            DO ji = 1, jpi                              
-               IF ( pssh(ji,jj) + ht_0(ji,jj) >  rn_wdmin1 ) THEN   ;   ptmsk(ji,jj) = 1._wp
-               ELSE                                                 ;   ptmsk(ji,jj) = 0._wp
-               ENDIF
-            END DO
-         END DO
+         DO_2D_11_11
+            IF ( pssh(ji,jj) + ht_0(ji,jj) >  rn_wdmin1 ) THEN   ;   ptmsk(ji,jj) = 1._wp
+            ELSE                                                 ;   ptmsk(ji,jj) = 0._wp
+            ENDIF
+         END_2D
       ENDIF
       !
@@ -1365,23 +1301,19 @@
       !!----------------------------------------------------------------------
       !
-      DO jj = 1, jpj
-         DO ji = 1, jpim1   ! not jpi-column
-            IF ( phU(ji,jj) > 0._wp ) THEN   ;   pUmsk(ji,jj) = pTmsk(ji  ,jj) 
-            ELSE                             ;   pUmsk(ji,jj) = pTmsk(ji+1,jj)  
-            ENDIF
-            phU(ji,jj) = pUmsk(ji,jj)*phU(ji,jj)
-            pu (ji,jj) = pUmsk(ji,jj)*pu (ji,jj)
-         END DO
-      END DO
-      !
-      DO jj = 1, jpjm1   ! not jpj-row
-         DO ji = 1, jpi
-            IF ( phV(ji,jj) > 0._wp ) THEN   ;   pVmsk(ji,jj) = pTmsk(ji,jj  )
-            ELSE                             ;   pVmsk(ji,jj) = pTmsk(ji,jj+1)  
-            ENDIF
-            phV(ji,jj) = pVmsk(ji,jj)*phV(ji,jj) 
-            pv (ji,jj) = pVmsk(ji,jj)*pv (ji,jj)
-         END DO
-      END DO
+      DO_2D_11_10
+         IF ( phU(ji,jj) > 0._wp ) THEN   ;   pUmsk(ji,jj) = pTmsk(ji  ,jj) 
+         ELSE                             ;   pUmsk(ji,jj) = pTmsk(ji+1,jj)  
+         ENDIF
+         phU(ji,jj) = pUmsk(ji,jj)*phU(ji,jj)
+         pu (ji,jj) = pUmsk(ji,jj)*pu (ji,jj)
+      END_2D
+      !
+      DO_2D_10_11
+         IF ( phV(ji,jj) > 0._wp ) THEN   ;   pVmsk(ji,jj) = pTmsk(ji,jj  )
+         ELSE                             ;   pVmsk(ji,jj) = pTmsk(ji,jj+1)  
+         ENDIF
+         phV(ji,jj) = pVmsk(ji,jj)*phV(ji,jj) 
+         pv (ji,jj) = pVmsk(ji,jj)*pv (ji,jj)
+      END_2D
       !
    END SUBROUTINE wad_Umsk
@@ -1399,44 +1331,42 @@
       REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) :: zcpx, zcpy
       !!----------------------------------------------------------------------
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1 
-            ll_tmp1 = MIN(  sshn(ji,jj)               ,  sshn(ji+1,jj) ) >                &
-                 &      MAX( -ht_0(ji,jj)               , -ht_0(ji+1,jj) ) .AND.            &
-                 &      MAX(  sshn(ji,jj) + ht_0(ji,jj) ,  sshn(ji+1,jj) + ht_0(ji+1,jj) )  &
-                 &                                                         > rn_wdmin1 + rn_wdmin2
-            ll_tmp2 = ( ABS( sshn(ji+1,jj)            -  sshn(ji  ,jj))  > 1.E-12 ).AND.( &
-                 &      MAX(   sshn(ji,jj)              ,  sshn(ji+1,jj) ) >                &
-                 &      MAX(  -ht_0(ji,jj)              , -ht_0(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
-            IF(ll_tmp1) THEN
-               zcpx(ji,jj) = 1.0_wp
-            ELSEIF(ll_tmp2) THEN
-               ! no worries about  sshn(ji+1,jj) -  sshn(ji  ,jj) = 0, it won't happen ! here
-               zcpx(ji,jj) = ABS( (sshn(ji+1,jj) + ht_0(ji+1,jj) - sshn(ji,jj) - ht_0(ji,jj)) &
-                    &    / (sshn(ji+1,jj) - sshn(ji  ,jj)) )
-               zcpx(ji,jj) = max(min( zcpx(ji,jj) , 1.0_wp),0.0_wp)
-            ELSE
-               zcpx(ji,jj) = 0._wp
-            ENDIF
-            !
-            ll_tmp1 = MIN(  sshn(ji,jj)               ,  sshn(ji,jj+1) ) >                &
-                 &      MAX( -ht_0(ji,jj)               , -ht_0(ji,jj+1) ) .AND.            &
-                 &      MAX(  sshn(ji,jj) + ht_0(ji,jj) ,  sshn(ji,jj+1) + ht_0(ji,jj+1) )  &
-                 &                                                       > rn_wdmin1 + rn_wdmin2
-            ll_tmp2 = ( ABS( sshn(ji,jj)              -  sshn(ji,jj+1))  > 1.E-12 ).AND.( &
-                 &      MAX(   sshn(ji,jj)              ,  sshn(ji,jj+1) ) >                &
-                 &      MAX(  -ht_0(ji,jj)              , -ht_0(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
-            
-            IF(ll_tmp1) THEN
-               zcpy(ji,jj) = 1.0_wp
-            ELSE IF(ll_tmp2) THEN
-               ! no worries about  sshn(ji,jj+1) -  sshn(ji,jj  ) = 0, it won't happen ! here
-               zcpy(ji,jj) = ABS( (sshn(ji,jj+1) + ht_0(ji,jj+1) - sshn(ji,jj) - ht_0(ji,jj)) &
-                    &             / (sshn(ji,jj+1) - sshn(ji,jj  )) )
-               zcpy(ji,jj) = MAX(  0._wp , MIN( zcpy(ji,jj) , 1.0_wp )  )
-            ELSE
-               zcpy(ji,jj) = 0._wp
-            ENDIF
-         END DO
-      END DO
+      DO_2D_00_00
+         ll_tmp1 = MIN(  sshn(ji,jj)               ,  sshn(ji+1,jj) ) >                &
+              &      MAX( -ht_0(ji,jj)               , -ht_0(ji+1,jj) ) .AND.            &
+              &      MAX(  sshn(ji,jj) + ht_0(ji,jj) ,  sshn(ji+1,jj) + ht_0(ji+1,jj) )  &
+              &                                                         > rn_wdmin1 + rn_wdmin2
+         ll_tmp2 = ( ABS( sshn(ji+1,jj)            -  sshn(ji  ,jj))  > 1.E-12 ).AND.( &
+              &      MAX(   sshn(ji,jj)              ,  sshn(ji+1,jj) ) >                &
+              &      MAX(  -ht_0(ji,jj)              , -ht_0(ji+1,jj) ) + rn_wdmin1 + rn_wdmin2 )
+         IF(ll_tmp1) THEN
+            zcpx(ji,jj) = 1.0_wp
+         ELSEIF(ll_tmp2) THEN
+            ! no worries about  sshn(ji+1,jj) -  sshn(ji  ,jj) = 0, it won't happen ! here
+            zcpx(ji,jj) = ABS( (sshn(ji+1,jj) + ht_0(ji+1,jj) - sshn(ji,jj) - ht_0(ji,jj)) &
+                 &    / (sshn(ji+1,jj) - sshn(ji  ,jj)) )
+            zcpx(ji,jj) = max(min( zcpx(ji,jj) , 1.0_wp),0.0_wp)
+         ELSE
+            zcpx(ji,jj) = 0._wp
+         ENDIF
+         !
+         ll_tmp1 = MIN(  sshn(ji,jj)               ,  sshn(ji,jj+1) ) >                &
+              &      MAX( -ht_0(ji,jj)               , -ht_0(ji,jj+1) ) .AND.            &
+              &      MAX(  sshn(ji,jj) + ht_0(ji,jj) ,  sshn(ji,jj+1) + ht_0(ji,jj+1) )  &
+              &                                                       > rn_wdmin1 + rn_wdmin2
+         ll_tmp2 = ( ABS( sshn(ji,jj)              -  sshn(ji,jj+1))  > 1.E-12 ).AND.( &
+              &      MAX(   sshn(ji,jj)              ,  sshn(ji,jj+1) ) >                &
+              &      MAX(  -ht_0(ji,jj)              , -ht_0(ji,jj+1) ) + rn_wdmin1 + rn_wdmin2 )
+         
+         IF(ll_tmp1) THEN
+            zcpy(ji,jj) = 1.0_wp
+         ELSE IF(ll_tmp2) THEN
+            ! no worries about  sshn(ji,jj+1) -  sshn(ji,jj  ) = 0, it won't happen ! here
+            zcpy(ji,jj) = ABS( (sshn(ji,jj+1) + ht_0(ji,jj+1) - sshn(ji,jj) - ht_0(ji,jj)) &
+                 &             / (sshn(ji,jj+1) - sshn(ji,jj  )) )
+            zcpy(ji,jj) = MAX(  0._wp , MIN( zcpy(ji,jj) , 1.0_wp )  )
+         ELSE
+            zcpy(ji,jj) = 0._wp
+         ENDIF
+      END_2D
             
    END SUBROUTINE wad_spg
@@ -1467,17 +1397,13 @@
       IF( ln_isfcav.OR.ln_drgice_imp ) THEN          ! top+bottom friction (ocean cavities)
          
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1     ! INNER domain
-               pCdU_u(ji,jj) = r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) + rCdU_top(ji+1,jj)+rCdU_top(ji,jj) )
-               pCdU_v(ji,jj) = r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) + rCdU_top(ji,jj+1)+rCdU_top(ji,jj) )
-            END DO
-         END DO
+         DO_2D_00_00
+            pCdU_u(ji,jj) = r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) + rCdU_top(ji+1,jj)+rCdU_top(ji,jj) )
+            pCdU_v(ji,jj) = r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) + rCdU_top(ji,jj+1)+rCdU_top(ji,jj) )
+         END_2D
       ELSE                          ! bottom friction only
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1  ! INNER domain
-               pCdU_u(ji,jj) = r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) )
-               pCdU_v(ji,jj) = r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) )
-            END DO
-         END DO
+         DO_2D_00_00
+            pCdU_u(ji,jj) = r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) )
+            pCdU_v(ji,jj) = r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) )
+         END_2D
       ENDIF
       !
@@ -1486,42 +1412,34 @@
       IF( ln_bt_fw ) THEN                 ! FORWARD integration: use NOW bottom baroclinic velocities
          
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1  ! INNER domain
-               ikbu = mbku(ji,jj)       
-               ikbv = mbkv(ji,jj)    
-               zu_i(ji,jj) = un(ji,jj,ikbu) - un_b(ji,jj)
-               zv_i(ji,jj) = vn(ji,jj,ikbv) - vn_b(ji,jj)
-            END DO
-         END DO
+         DO_2D_00_00
+            ikbu = mbku(ji,jj)       
+            ikbv = mbkv(ji,jj)    
+            zu_i(ji,jj) = uu(ji,jj,ikbu,Nii) - un_b(ji,jj)
+            zv_i(ji,jj) = vv(ji,jj,ikbv,Nii) - vn_b(ji,jj)
+         END_2D
       ELSE                                ! CENTRED integration: use BEFORE bottom baroclinic velocities
          
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1   ! INNER domain
-               ikbu = mbku(ji,jj)       
-               ikbv = mbkv(ji,jj)    
-               zu_i(ji,jj) = ub(ji,jj,ikbu) - ub_b(ji,jj)
-               zv_i(ji,jj) = vb(ji,jj,ikbv) - vb_b(ji,jj)
-            END DO
-         END DO
+         DO_2D_00_00
+            ikbu = mbku(ji,jj)       
+            ikbv = mbkv(ji,jj)    
+            zu_i(ji,jj) = uu(ji,jj,ikbu,Nnn) - ub_b(ji,jj)
+            zv_i(ji,jj) = vv(ji,jj,ikbv,Nnn) - vb_b(ji,jj)
+         END_2D
       ENDIF
       !
       IF( ln_wd_il ) THEN      ! W/D : use the "clipped" bottom friction   !!gm   explain WHY, please !
          zztmp = -1._wp / rdtbt
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1    ! INNER domain
-               pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + zu_i(ji,jj) *  wdrampu(ji,jj) * MAX(                                 & 
-                    &                              r1_hu_n(ji,jj) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) , zztmp  )
-               pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + zv_i(ji,jj) *  wdrampv(ji,jj) * MAX(                                 & 
-                    &                              r1_hv_n(ji,jj) * r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) , zztmp  )
-            END DO
-         END DO
+         DO_2D_00_00
+            pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + zu_i(ji,jj) *  wdrampu(ji,jj) * MAX(                                 & 
+                 &                              r1_hu_n(ji,jj) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) , zztmp  )
+            pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + zv_i(ji,jj) *  wdrampv(ji,jj) * MAX(                                 & 
+                 &                              r1_hv_n(ji,jj) * r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) , zztmp  )
+         END_2D
       ELSE                    ! use "unclipped" drag (even if explicit friction is used in 3D calculation)
          
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1    ! INNER domain
-               pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu_n(ji,jj) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * zu_i(ji,jj)
-               pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + r1_hv_n(ji,jj) * r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * zv_i(ji,jj)
-            END DO
-         END DO
+         DO_2D_00_00
+            pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu_n(ji,jj) * r1_2*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * zu_i(ji,jj)
+            pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + r1_hv_n(ji,jj) * r1_2*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * zv_i(ji,jj)
+         END_2D
       END IF
       !
@@ -1532,32 +1450,26 @@
          IF( ln_bt_fw ) THEN                ! FORWARD integration: use NOW top baroclinic velocity
             
-            DO jj = 2, jpjm1
-               DO ji = 2, jpim1   ! INNER domain
-                  iktu = miku(ji,jj)
-                  iktv = mikv(ji,jj)
-                  zu_i(ji,jj) = un(ji,jj,iktu) - un_b(ji,jj)
-                  zv_i(ji,jj) = vn(ji,jj,iktv) - vn_b(ji,jj)
-               END DO
-            END DO
+            DO_2D_00_00
+               iktu = miku(ji,jj)
+               iktv = mikv(ji,jj)
+               zu_i(ji,jj) = uu(ji,jj,iktu,Nii) - un_b(ji,jj)
+               zv_i(ji,jj) = vv(ji,jj,iktv,Nii) - vn_b(ji,jj)
+            END_2D
          ELSE                                ! CENTRED integration: use BEFORE top baroclinic velocity
             
-            DO jj = 2, jpjm1
-               DO ji = 2, jpim1      ! INNER domain
-                  iktu = miku(ji,jj)
-                  iktv = mikv(ji,jj)
-                  zu_i(ji,jj) = ub(ji,jj,iktu) - ub_b(ji,jj)
-                  zv_i(ji,jj) = vb(ji,jj,iktv) - vb_b(ji,jj)
-               END DO
-            END DO
+            DO_2D_00_00
+               iktu = miku(ji,jj)
+               iktv = mikv(ji,jj)
+               zu_i(ji,jj) = uu(ji,jj,iktu,Nnn) - ub_b(ji,jj)
+               zv_i(ji,jj) = vv(ji,jj,iktv,Nnn) - vb_b(ji,jj)
+            END_2D
          ENDIF
          !
          !                    ! use "unclipped" top drag (even if explicit friction is used in 3D calculation)
          
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1    ! INNER domain
-               pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu_n(ji,jj) * r1_2*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * zu_i(ji,jj)
-               pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + r1_hv_n(ji,jj) * r1_2*( rCdU_top(ji,jj+1)+rCdU_top(ji,jj) ) * zv_i(ji,jj)
-            END DO
-         END DO
+         DO_2D_00_00
+            pu_RHSi(ji,jj) = pu_RHSi(ji,jj) + r1_hu_n(ji,jj) * r1_2*( rCdU_top(ji+1,jj)+rCdU_top(ji,jj) ) * zu_i(ji,jj)
+            pv_RHSi(ji,jj) = pv_RHSi(ji,jj) + r1_hv_n(ji,jj) * r1_2*( rCdU_top(ji,jj+1)+rCdU_top(ji,jj) ) * zv_i(ji,jj)
+         END_2D
          !
       ENDIF
